import "./carousel.css";
import { defineComponent as S, openBlock as l, createElementBlock as h, mergeProps as T, Fragment as f, createElementVNode as g, createBlock as p, resolveDynamicComponent as m, normalizeClass as u, createCommentVNode as c, normalizeStyle as y, renderList as w, renderSlot as D, normalizeProps as C, guardReactiveProps as $, createTextVNode as I, toDisplayString as P } from "vue";
import { f as k, b } from "../../icons-fca12ed8.js";
import { _ as R } from "../../_plugin-vue_export-helper-dad06003.js";
const v = (e, t) => Array.from(
  { length: t - e + 1 },
  (n, r) => e + r * 1
), W = (e) => [...e].sort(
  (n, r) => n.breakpoint - r.breakpoint
), B = S({
  props: {
    arrow: {
      default: !0,
      type: Boolean
    },
    autoplay: {
      required: !1,
      type: Boolean
    },
    cardsToShow: {
      default: 1,
      type: Number
    },
    dots: {
      default: !0,
      type: Boolean
    },
    infinite: {
      required: !1,
      type: Boolean
    },
    list: {
      required: !0,
      type: Object
    },
    responsive: {
      required: !1,
      type: Object
    },
    speed: {
      default: 3e3,
      type: Number
    }
  },
  name: "sb-carousel",
  data() {
    return {
      autoplayInterval: null,
      cardWidth: 0,
      cardsDisplay: [],
      carouselWrapper: null,
      currentPage: 1,
      endDrag: -1,
      isDrag: !1,
      isMounted: !1,
      isSmallScreen: !1,
      localDots: [],
      localResponsives: [],
      sliderStyle: [],
      startDrag: -1
    };
  },
  computed: {
    iconAngleLeft() {
      return k();
    },
    iconAngleRight() {
      return b();
    },
    isDotsEnabled() {
      if (this.responsive && typeof window < "u") {
        const e = this.localResponsives.find(
          (t) => t.breakpoint === window.innerWidth
        );
        if (e)
          return e.settings.dots || this.dots;
      }
      return this.dots;
    },
    isInfinite() {
      if (this.responsive && typeof window < "u") {
        const e = this.localResponsives.find(
          (t) => t.breakpoint === window.innerWidth
        );
        if (e)
          return e.settings.infinite || this.infinite;
      }
      return this.infinite;
    }
  },
  methods: {
    getCardsToShow() {
      if (this.responsive && typeof window < "u") {
        const e = this.localResponsives.find(
          (t) => t.breakpoint >= window.innerWidth
        );
        if (e)
          return e.settings.cardsToShow || this.cardsToShow;
      }
      return this.cardsToShow;
    },
    handleDot(e) {
      if (!this.isInfinite)
        this.currentPage = e, this.$nextTick(() => {
          this.handleScrollBasic();
        });
      else {
        const t = this.currentPage;
        this.currentPage = e, this.$nextTick(() => {
          this.handleScrollInfinite(e - t);
        });
      }
    },
    handleDrag(e) {
      e.cancelable && e.preventDefault(), e.movementX ? this.endDrag = e.movementX : e.changedTouches && (this.endDrag = e.changedTouches[0].clientX);
    },
    handleDragEnd(e) {
      e.cancelable && e.preventDefault(), this.isDrag && (this.startDrag > this.endDrag ? (!this.isInfinite && this.currentPage < this.localDots.length || this.isInfinite) && this.handleNav(1) : this.startDrag < this.endDrag && (!this.isInfinite && this.currentPage > 1 || this.isInfinite) && this.handleNav(-1), this.isDrag = !1);
    },
    handleDragStart(e) {
      e.cancelable && e.preventDefault(), e.movementX ? this.startDrag = e.movementX : e.changedTouches && (this.startDrag = e.changedTouches[0].clientX), this.isDrag = !0;
    },
    handleInitCards() {
      typeof window < "u" && (this.modifyCards(), this.$nextTick(() => {
        this.localDots = Array.from(
          Array(
            Math.ceil(
              this.list.length / this.getCardsToShow()
            )
          ).keys()
        ), this.setSliderStyles(), this.$nextTick(() => {
          var e;
          if (this.$refs.slider && this.isInfinite && this.carouselWrapper) {
            const n = this.carouselWrapper.getBoundingClientRect().width + 16;
            (e = this.$refs.slider) == null || e.scrollTo({
              left: n
            });
          }
        });
      }));
    },
    handleNav(e) {
      this.isInfinite ? (e < 0 && this.currentPage < 2 ? this.currentPage = this.localDots.length : e > 0 && this.currentPage === this.localDots.length ? this.currentPage = 1 : this.currentPage += e, this.$nextTick(() => {
        this.handleScrollInfinite(e);
      })) : (e < 0 && this.currentPage > 1 || e > 0 && this.currentPage < this.list.length) && (this.currentPage += e, this.$nextTick(() => {
        this.handleScrollBasic();
      }));
    },
    handleResize() {
      this.handleInitCards();
    },
    handleScrollBasic() {
      var e;
      this.$refs.slider && ((e = this.$refs.slider) == null || e.scrollTo({
        behavior: "smooth",
        left: (this.currentPage - 1) * this.carouselWrapper.getBoundingClientRect().width + (this.currentPage > 1 ? 16 * (this.currentPage - 1) : 0)
      }));
    },
    handleScrollInfinite(e) {
      if (this.$refs.slider) {
        const t = this.$refs.slider.scrollLeft, n = this.carouselWrapper.getBoundingClientRect().width, r = n + 16;
        this.modifyCards(), e < 0 ? this.$nextTick(() => {
          var o;
          (o = this.$refs.slider) == null || o.scrollTo({
            left: t + n + r
          }), setTimeout(() => {
            var i;
            (i = this.$refs.slider) == null || i.scrollTo({
              behavior: "smooth",
              left: r
            });
          }, 50);
        }) : this.$nextTick(() => {
          var o;
          (o = this.$refs.slider) == null || o.scrollTo({
            left: 0
          }), setTimeout(() => {
            var i;
            (i = this.$refs.slider) == null || i.scrollTo({
              behavior: "smooth",
              left: r
            });
          }, 50);
        });
      }
    },
    isCardActive(e) {
      return this.isInfinite ? e >= this.getCardsToShow() && e < this.getCardsToShow() * 2 : e >= this.currentPage - 1 * this.getCardsToShow() && e < this.currentPage * this.getCardsToShow();
    },
    modifyCards() {
      if (this.isInfinite) {
        const t = [...(() => {
          let i = 0, s = 0;
          return this.currentPage < 2 ? (i = (this.localDots.length - 1) * this.getCardsToShow(), s = this.localDots.length * this.getCardsToShow()) : (i = (this.currentPage - 2) * this.getCardsToShow(), s = (this.currentPage - 1) * this.getCardsToShow()), [...v(i, s - 1)].map((a) => a < 0 ? this.list.length + a : a >= this.list.length ? a - this.list.length : a);
        })()].map(
          (i) => this.list[i]
        ), r = [...(() => {
          let i = 0, s = 0;
          return this.currentPage === this.localDots.length ? (i = 0, s = this.getCardsToShow()) : (i = this.currentPage * this.getCardsToShow(), s = (this.currentPage + 1) * this.getCardsToShow()), [...v(i, s - 1)].map((a) => a < 0 ? this.list.length + a : a >= this.list.length ? a - this.list.length : a);
        })()].map(
          (i) => this.list[i]
        ), o = [...this.list].filter(
          (i, s) => s >= (this.currentPage - 1) * this.getCardsToShow() && s < this.currentPage * this.getCardsToShow()
        );
        return this.cardsDisplay = [
          ...t,
          ...o,
          ...r
        ];
      }
      return this.cardsDisplay = [...this.list];
    },
    setSliderStyles() {
      var n, r;
      const e = this.getCardsToShow(), t = (r = (n = this.carouselWrapper) == null ? void 0 : n.getBoundingClientRect()) == null ? void 0 : r.width;
      t && (this.sliderStyle = [
        `grid-auto-columns: calc((100% - ${(e - 1) * 16}px) / ${e})`
      ], this.cardWidth = (t - (e - 1) * 16) / e);
    }
  },
  watch: {
    autoplay: {
      handler(e) {
        this.autoplayInterval && (clearInterval(this.autoplayInterval), this.autoplayInterval = null), e && this.speed && this.isInfinite && this.$nextTick(() => {
          this.autoplayInterval = setInterval(() => {
            this.handleNav(1);
          }, this.speed);
        });
      },
      immediate: !0
    },
    cardsToShow() {
      this.handleInitCards();
    },
    list: {
      deep: !0,
      handler() {
        this.handleInitCards();
      }
    },
    responsive: {
      deep: !0,
      handler(e) {
        e ? this.localResponsives = [...W(e)] : this.localResponsives = [];
      },
      immediate: !0
    }
  },
  mounted() {
    this.isMounted = !0, window.innerWidth <= 600 && (this.isSmallScreen = !0), this.$refs["carousel-wrapper"] && (this.carouselWrapper = this.$refs["carousel-wrapper"]), this.$nextTick(() => {
      this.handleInitCards();
    }), window.addEventListener("resize", this.handleResize);
  },
  unmounted() {
    this.isMounted = !1, window.removeEventListener("resize", this.handleResize);
  }
});
const N = { class: "slider-wrapper" }, A = {
  key: 0,
  class: "dots-wrapper"
}, E = ["onClick"], z = {
  key: 1,
  class: "carousel-loader"
};
function M(e, t, n, r, o, i) {
  return l(), h("div", T({
    class: "carousel-wrapper",
    ref: "carousel-wrapper"
  }, { ...e.$attrs }), [
    e.isMounted ? (l(), h(f, { key: 0 }, [
      g("div", N, [
        !e.isSmallScreen && e.arrow ? (l(), p(m(e.iconAngleLeft), {
          key: 0,
          class: u(["nav", { "sb-hidden": !e.isInfinite && e.currentPage < 2 }]),
          onClick: t[0] || (t[0] = (s) => e.handleNav(-1))
        }, null, 8, ["class"])) : c("", !0),
        !e.isSmallScreen && e.arrow ? (l(), p(m(e.iconAngleRight), {
          key: 1,
          class: u(["nav", {
            "sb-hidden": !e.isInfinite && e.currentPage === e.localDots.length
          }]),
          onClick: t[1] || (t[1] = (s) => e.handleNav(1))
        }, null, 8, ["class"])) : c("", !0),
        g("div", {
          draggable: "true",
          class: u(["slider", {
            grabbing: e.isDrag
          }]),
          ref: "slider",
          style: y(e.sliderStyle),
          onMousedown: t[2] || (t[2] = (s) => e.handleDragStart(s)),
          onMousemove: t[3] || (t[3] = (s) => e.handleDrag(s)),
          onMouseup: t[4] || (t[4] = (s) => e.handleDragEnd(s)),
          onTouchstart: t[5] || (t[5] = (s) => e.handleDragStart(s)),
          onTouchmove: t[6] || (t[6] = (s) => e.handleDrag(s)),
          onTouchend: t[7] || (t[7] = (s) => e.handleDragEnd(s))
        }, [
          e.list ? (l(!0), h(f, { key: 0 }, w(e.cardsDisplay, (s, d) => (l(), h("div", {
            class: u(["card", {
              active: e.isCardActive(d)
            }]),
            key: `card-${d}`
          }, [
            D(e.$slots, "card", C($({ data: s })), () => [
              I(P(s), 1)
            ])
          ], 2))), 128)) : c("", !0)
        ], 38)
      ]),
      e.isDotsEnabled ? (l(), h("div", A, [
        (l(!0), h(f, null, w(e.localDots, (s, d) => (l(), h("div", {
          class: u(["button", {
            active: e.currentPage - 1 === d
          }]),
          key: s,
          onClick: (a) => e.handleDot(d + 1)
        }, null, 10, E))), 128))
      ])) : c("", !0)
    ], 64)) : (l(), h("div", z))
  ], 16);
}
const j = /* @__PURE__ */ R(B, [["render", M]]);
export {
  j as default
};
