import { IIcon } from '../../interface';
import { PropType } from 'vue';
declare const _default: import("vue").DefineComponent<{
    autocomplete: {
        default: string;
        type: PropType<"on" | "off">;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    icon: {
        required: false;
        type: PropType<IIcon>;
    };
    invalidNumberMessage: {
        default: string;
        type: StringConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isFocus: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    max: {
        required: false;
        type: NumberConstructor;
    };
    maxDecimalPlaces: {
        default: number;
        type: NumberConstructor;
    };
    min: {
        required: false;
        type: NumberConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<string | number | null>;
    };
    numberLocale: {
        default: string;
        type: PropType<"en-US" | "id-ID">;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    step: {
        default: number;
        type: NumberConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    textAlign: {
        default: string;
        type: PropType<"left" | "right">;
    };
    value: {
        required: false;
        type: PropType<string | number | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
    withLocale: {
        default: boolean;
        type: BooleanConstructor;
    };
}, unknown, {
    localIsFocus: boolean;
    isInvalidNumber: boolean;
    localValue: any;
}, {
    getMaskaOptions(): {
        mask: string;
        preProcess: (val: string | number) => string;
        tokens: {
            '#': {
                optional: boolean;
                pattern: RegExp;
            };
            0: {
                multiple: boolean;
                pattern: RegExp;
            };
            9?: undefined;
        };
        postProcess?: undefined;
    } | {
        mask: string;
        preProcess: (val: string | number) => string;
        tokens: {
            '#': {
                optional: boolean;
                pattern: RegExp;
            };
            0: {
                multiple: boolean;
                pattern: RegExp;
            };
            9: {
                optional: boolean;
                pattern: RegExp;
            };
        };
        postProcess?: undefined;
    } | {
        postProcess: (val: string | number) => string | number;
        preProcess: (val: any) => string;
        mask?: undefined;
        tokens?: undefined;
    };
    iconSortDown(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    iconSortUp(): import("vue").VNode<import("vue").RendererNode, import("vue").RendererElement, {
        [key: string]: any;
    }>;
    isFilled(): any;
}, {
    getRealValue(masked: string): number | null;
    handleBlur(ev: Event): void;
    handleChange(ev: Event): void;
    handleClickIcon(ev: Event): void | undefined;
    handleClickOutsideInput(event: MouseEvent): void;
    handleClickStep(inc: number): void;
    handleErrorMessage(): any;
    handleInputChange(ev: Event): void;
    handleInputFocus(ev: Event): void;
    handleKeydown(ev: KeyboardEvent): void;
    handleMouseLeaveIcon(ev: Event): void | undefined;
    handleMouseOverIcon(ev: Event): void | undefined;
    handlePaste(ev: ClipboardEvent): void;
    handleValueProp(value: any): void;
    toggleFocus(focus: boolean, event?: Event): void;
}, import("vue").ComponentOptionsMixin, import("vue").ComponentOptionsMixin, {
    'update:modelValue': (_value: number | string | null) => true;
    blur: (_event: Event) => true;
    change: (_event: Event) => true;
    focus: (_event: Event) => true;
    input: (_event: Event) => true;
    keydown: (_event: Event) => true;
}, string, import("vue").VNodeProps & import("vue").AllowedComponentProps & import("vue").ComponentCustomProps, Readonly<import("vue").ExtractPropTypes<{
    autocomplete: {
        default: string;
        type: PropType<"on" | "off">;
    };
    disabled: {
        required: false;
        type: BooleanConstructor;
    };
    errorMessage: {
        required: false;
        type: (StringConstructor | FunctionConstructor)[];
    };
    icon: {
        required: false;
        type: PropType<IIcon>;
    };
    invalidNumberMessage: {
        default: string;
        type: StringConstructor;
    };
    isError: {
        required: false;
        type: BooleanConstructor;
    };
    isFocus: {
        required: false;
        type: BooleanConstructor;
    };
    label: {
        required: false;
        type: StringConstructor;
    };
    max: {
        required: false;
        type: NumberConstructor;
    };
    maxDecimalPlaces: {
        default: number;
        type: NumberConstructor;
    };
    min: {
        required: false;
        type: NumberConstructor;
    };
    modelValue: {
        required: false;
        type: PropType<string | number | null>;
    };
    numberLocale: {
        default: string;
        type: PropType<"en-US" | "id-ID">;
    };
    placeholder: {
        required: false;
        type: StringConstructor;
    };
    readOnly: {
        required: false;
        type: BooleanConstructor;
    };
    required: {
        required: false;
        type: BooleanConstructor;
    };
    step: {
        default: number;
        type: NumberConstructor;
    };
    tabindex: {
        required: false;
        type: NumberConstructor;
    };
    textAlign: {
        default: string;
        type: PropType<"left" | "right">;
    };
    value: {
        required: false;
        type: PropType<string | number | null>;
    };
    variant: {
        default: string;
        required: false;
        type: PropType<"default" | "flat">;
    };
    withLocale: {
        default: boolean;
        type: BooleanConstructor;
    };
}>> & {
    onFocus?: ((_event: Event) => any) | undefined;
    onBlur?: ((_event: Event) => any) | undefined;
    onChange?: ((_event: Event) => any) | undefined;
    onInput?: ((_event: Event) => any) | undefined;
    onKeydown?: ((_event: Event) => any) | undefined;
    "onUpdate:modelValue"?: ((_value: string | number | null) => any) | undefined;
}, {
    required: boolean;
    disabled: boolean;
    variant: "default" | "flat";
    isError: boolean;
    isFocus: boolean;
    autocomplete: "on" | "off";
    readOnly: boolean;
    step: number;
    textAlign: "left" | "right";
    invalidNumberMessage: string;
    maxDecimalPlaces: number;
    numberLocale: "en-US" | "id-ID";
    withLocale: boolean;
}, {}>;
export default _default;
