import "./menu.css";
import { defineComponent as d, resolveComponent as c, openBlock as n, createElementBlock as s, normalizeProps as h, guardReactiveProps as u, createElementVNode as m, createVNode as f, mergeProps as v, withModifiers as S, withCtx as y, renderSlot as r, createTextVNode as b, toDisplayString as g, createBlock as $, Teleport as P, normalizeStyle as w, createCommentVNode as W } from "vue";
import C from "../button/button.js";
import { r as l } from "../../helper-4d4ed314.js";
import { _ } from "../../_plugin-vue_export-helper-dad06003.js";
import "../tooltip/tooltip.js";
const k = d({
  props: {
    color: {
      default: "default",
      type: String
    },
    disabled: {
      default: !1,
      type: Boolean
    },
    label: {
      required: !1,
      type: String
    },
    noElevation: {
      required: !1,
      type: Boolean
    },
    open: {
      required: !1,
      type: Boolean
    },
    size: {
      default: "base",
      type: String
    },
    tooltip: {
      required: !1,
      type: String
    },
    variant: {
      default: "contained",
      type: String
    }
  },
  name: "sb-menu",
  components: {
    "sb-button": C
  },
  data() {
    return {
      localOpen: !1,
      itemsWrapperStyles: [],
      parentWithScroll: null
    };
  },
  methods: {
    handleClose(e) {
      const o = e.target, t = this.$refs["menu-wrapper"];
      o && t && !t.contains(o) && !o.isSameNode(t) && (this.localOpen = !1);
    },
    handleOpen() {
      this.disabled || (this.localOpen = !0, this.$nextTick(() => {
        this.setPopupPosition();
      }));
    },
    handleParentScroll(e) {
      const o = l(this.$el);
      this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
        this.setPopupPosition();
      }), o && (e ? o.addEventListener("scroll", () => {
        this.setPopupPosition();
      }) : o.removeEventListener("scroll", () => {
        this.setPopupPosition();
      })), this.$nextTick(() => {
        this.parentWithScroll = o;
      });
    },
    setPopupPosition() {
      var o;
      const e = this.$refs["menu-wrapper"];
      if (e) {
        const t = e.getBoundingClientRect(), i = (o = this.$refs["menu-items-wrapper"]) == null ? void 0 : o.getBoundingClientRect();
        if (i)
          return document.body.getBoundingClientRect().height - (t.height + t.y) <= i.height ? this.itemsWrapperStyles = {
            left: `${t.x}px`,
            top: `${t.y - 6 - i.height}px`,
            width: `${t.width}px`
          } : this.itemsWrapperStyles = {
            left: `${t.x}px`,
            top: `${t.y + t.height}px`,
            width: `${t.width}px`
          };
      }
    }
  },
  watch: {
    localOpen(e) {
      this.handleParentScroll(e);
    }
  },
  mounted() {
    this.localOpen = this.open, this.$nextTick(() => this.setPopupPosition()), document.addEventListener(
      "click",
      (e) => this.handleClose(e)
    ), this.parentWithScroll = l(this.$el);
  },
  unmounted() {
    document.removeEventListener(
      "click",
      (e) => this.handleClose(e)
    ), this.parentWithScroll && this.parentWithScroll.removeEventListener("scroll", () => {
      this.setPopupPosition();
    });
  }
});
const B = {
  class: "menu-wrapper",
  ref: "menu-wrapper"
};
function E(e, o, t, i, a, O) {
  const p = c("sb-button");
  return n(), s("div", h(u({ ...e.$attrs })), [
    m("div", B, [
      f(p, v({
        "no-elevation": e.localOpen || e.noElevation,
        type: "button"
      }, {
        color: e.color,
        disabled: e.disabled,
        size: e.size,
        tooltip: e.tooltip,
        variant: e.variant
      }, {
        onClick: S(e.handleOpen, ["stop"])
      }), {
        default: y(() => [
          r(e.$slots, "slot-label", {}, () => [
            b(g(e.label || "..."), 1)
          ], !0)
        ]),
        _: 3
      }, 16, ["no-elevation", "onClick"])
    ], 512),
    (n(), $(P, { to: "body" }, [
      e.localOpen ? (n(), s("div", {
        key: 0,
        class: "menu-items-wrapper",
        ref: "menu-items-wrapper",
        style: w(e.itemsWrapperStyles)
      }, [
        r(e.$slots, "default", {}, void 0, !0)
      ], 4)) : W("", !0)
    ]))
  ], 16);
}
const q = /* @__PURE__ */ _(k, [["render", E], ["__scopeId", "data-v-b9996b24"]]);
export {
  q as default
};
